## 01204322 Embedded Systems

Department of Computer Engineering Faculty of Engineering Kasetsart University

Group: Tatake!!!

Project Name: Stupid Box

Developer:

-6210503675 บุญรักษา บัวรักษา
-6210503861 สินธนา วงษ์สุภักดี
-6210505236 วิภู ศรีทองกิติกูล
-6210505228 มกร อธิปฏิพัทธ์

Hardware:

- node MCU 3 board
- ESP8266 1 board
- DHT11 sensor
- Mq2 sensor
- PMS3003 sensor
- Dot metric

Software:

- Arduino IDE
- Thonny
- Visual Studio Code

Library list in used:

- max7219 (Dot Matrix)
- dht (DHT)
- ConnectWifi (Server)
- network (Server)
- socket (Server)
- gc (Server)
- json (Server)
- machine (Server)
- time (MQ2, DHT)
- math (MQ2)
- sys (MQ2)
- SoftwareSerial.h (PMS)
- ESP8266WIFI.h (PMS)
- WiFiClient.h (PMS)
- ArduinoJson.h (PMS)

Source Code:

- Board A (dht): main.py, ConnectWifi.py
- Board B (Dot Matrix and Server): server.py, ConnectWifi.py
- Board C (mq2): main.py, ConnectWifi.py
- Board D (PMS3003): PMS3003.ino
- Website: folder web

Dataflow:

![DataFlow](Dataflow/dataflow-01.png "DataFlow")

การทำงานของแต่ละบอร์ด :
- Board A (dht): วัดค่าอุณหภูมิและความชื้นจากนั้นส่งข้อมูลไปแสดงที่หน้าเว็บ
- Board B (Dot Matrix and Server): รับค่า pm 2.5 จาก Board D และส่งค่าไปแสดงบนหน้าเว็บ, รับค่า smoke จาห Board C และแสดงผลบน Dot Matrix
- Board C (mq2): วัดค่าจากเซนเซอร์ จากนั้นนำไปคำนวณเพื่อหาปริมาณของก๊าซชนิดต่าง ๆ จากนั้นส่งข้อมูลไปแสดงที่หน้าเว็บ และส่งค่า Smoke ไปที่ Board B
- Board D (PMS3003): วัดค่าปริมาณฝุ่น Pm 1,2.5,10 แล้วทำการส่งข้อมูลไปที่ Board B
- Website: รับ api จาก Board และแสดงผลบนหน้าเว็บ

Technique:

- บอร์ด A: สามารถรับค่าอุณหภูมิกับความชื้นมาจากเซนเซอร์ dht ได้โดยตรง โดยที่บอร์ดจะทำการต่อ Wifi โดยที่ Fixed ip address เอาไว้ จากนั้นก็สร้าง Socket ขึ้นมาและตั้งค่า port เอาไว้ เพื่อที่ให้ เว็บ site เข้ามาเชื่อมต่อและรับค่าไป
- บอร์ด B: จะทำการต่อ Wifi โดยที่ Fixed ip address เอาไว้ จากนั้นก็สร้าง socket ขึ้นมา 3 ตัว โดยกำหนดเป็นคนละ Port อันหนึ่งเอาไว้รับค่า pm 2.5 มาจากบอร์ด D และ socket ตัวที่สองเอาไว้ส่งค่าที่ได้มากจากบอร์ด D ไปที่ website และตัวสุดท้าย คอยรับค่า smoke มาจากบอร์ด C และทำการเช็คว่าค่า smoke ที่ได้มามีค่า มาก, น้อย หรือปานกลาง จากนั้นก็แสดงผลข้อมูลบน Dot Matrix
- บอร์ด C: สามารถรับค่ามลพิษในอากาศจาก mq2 sensor ได้โดยเราจะเก็บข้อมูลเป็น analog จากนั้นนำค่า mq2 ที่ได้ไปคำนวณเป็นค่า ppm เก็บแก๊สชนิดต่างๆ ได้แก่ H2, LPG, Methane, CO, Alcohol, Smoke, Propane โดยใช้สูตร ดังนี้ x = 10 ^ {[log(y) - b] / m} จากนั้นนำค่าที่ได้มาตรวจสอบว่าเกิน 1000 ppm มั้ยถ้าเกินแปลว่าอากาศมีมลพิษ
- บอร์ด D: ในการวัดปริมาณฝุ่น PM ต่างๆในอากาศตัวเซนเซอร์จะมีการรับส่งข้อมูลแบบอนุกรม (Serial) โดยค่าที่ได้มานั้นจะถูกนำมาคิดคำนวณต่อเพื่อให้ได้ปริมาณ PM แต่ละตัว ในการส่งข้อมูลนั้นตัวบอร์ดจะทำการเชื่อม Wifi และส่งข้อมูลสตริงในรูปแบบ JSON ไปยังบอร์ด B เพื่อส่งข้อมูลขึ้น website ต่อไป 
- website: ใช้ react เป็น frontend และใช้ express เป็น backend run on port 9000 มี menu เพื่อใช้ไปยังหน้า sensor แต่ละหน้า มี graph แสดงค่า sensor 

Presentation Video:

https://www.youtube.com/watch?v=pPjl7qkngfQ&list=LL&index=3&t=5s

*หมายเหตุ ไม่มีรูปสมาชิกที่ชัดเจนถ่ายไว้ตอนทำผลงาน

