import ConnectWiFi
import network
from network import WLAN
import socket
import gc
import json
from machine import Pin, SPI
import max7219

s = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
s.bind(('',61))
s.listen(5)

so = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
so.bind(('',60))
so.listen(5)

s2 = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
s2.bind(('',80))
s2.listen(5)

spi = SPI(1, baudrate=10000000, polarity=1, phase=0, sck=Pin(14), mosi=Pin(13))
ss = Pin(15, Pin.OUT)
display = max7219.Matrix8x8(spi, ss, 8)

display.fill(0)
display.show()

def smoke(value):
    display.fill(0)
    display.show()
    display.text("S",0,0,1)
    display.text("M",7,0,1)
    display.text("O",8*2,0,1)
    display.text("K",8*3+1,0,1)
    display.text(value,8*4,1,1)
    display.show();

def sendServer(data):
    try:
        conn, addr = so.accept()
        conn.send('HTTP/1.1 200 OK\n')
        conn.send('Access-Control-Allow-Origin: *\n')
        conn.send('Content-Type: application/json\n')
        conn.send('Connection: close\n\n')
        conn.write(data)
        conn.close()
    except:
        print("Connecting to database...")
        
def recieveData():
    conn, addr = s2.accept()
    print('Got a connection from %s' % str(addr))
    received = conn.recv(1024)
    conn.send('HTTP/1.1 200 OK\n')
    conn.send('Access-Control-Allow-Origin: *\n')
    conn.send('Content-Type: application/json\n')
    conn.send('Connection: close\n\n')
    conn.close()
    return received

def recievepm25():
    pm25=""
    conn, addr = s.accept()
    print('Got a connection from %s' % str(addr))
    while True:
        received = conn.recv(1024)
        received_decode = received.decode("utf-8")
        pm25+=received_decode
        check = 0
        for i in range(len(received_decode)):
            if received_decode[i] == '}':
                check = 1
                break
        if check == 1:
            break
    conn.send('HTTP/1.1 200 OK\n')
    conn.send('Access-Control-Allow-Origin: *\n')
    conn.send('Content-Type: application/json\n')
    conn.send('Connection: close\n\n')
    conn.close()
    return pm25

ConnectWiFi.connect()

while True:
    sendServer(recievepm25())
    if float(recieveData()) >= 1000:
        smoke("HIGH")
    else:
        smoke("NORM")