from machine import Pin, ADC
from time import sleep
import math
import ConnectWiFi
import network
import socket
import json
import sys

def PostData(data):
    s = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    try:
        s.connect(('172.20.10.13', 80))
        smoke = str(data)
        s.write(smoke)
        s.close()
    except Exception:
        print("Reconnecting to the server...")

so = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
so.bind(('',60))
so.listen(5)
def sendServer(data):
    try:
        conn, addr = so.accept()
        response = json.dumps(data)
        conn.send('HTTP/1.1 200 OK\n')
        conn.send('Access-Control-Allow-Origin: *\n')
        conn.send('Content-Type: application/json\n')
        conn.send('Connection: close\n\n')
        conn.write(response)
        conn.close()
    except:
        print("Connecting to database...")

mq2 = ADC(Pin(36))
digital_mq2 = Pin(22)
mq2.atten(ADC.ATTN_11DB)
Vin = 5

ConnectWiFi.connect()
ssid = "Huawei P30 Pro"
password = "11111111"
station = network.WLAN(network.STA_IF)
station.active(True)
station.connect(ssid, password)
print(station.ifconfig())

while True:
    mq2_value = []
    for i in range(6000):
        mq2_value.append(mq2.read())
    mq2_value_average = sum(mq2_value)/6000
    mq2_value_average_volt = mq2_value_average*5/1023
    RS = (Vin-mq2_value_average_volt)/mq2_value_average_volt
    R0 = RS/9.8
    mq2_value_read = mq2.read()
    mq2_value_read_volt = mq2_value_read*5/1023
    RS = (Vin-mq2_value_read_volt)/mq2_value_read_volt
    RS_RO_ratio = RS/R0
    ppmH2 = 10**((math.log10(RS_RO_ratio)-1.412572126)/(-0.47305447))
    ppmLPG = 10**((math.log10(RS_RO_ratio)-1.25063406)/(-0.454838059))
    ppmMethane = 10**((math.log10(RS_RO_ratio)-1.349158571)/(-0.372003751))
    ppmCO = 10**((math.log10(RS_RO_ratio)-1.512022272)/(-0.33975668))
    ppmAlcohol = 10**((math.log10(RS_RO_ratio)-1.310286169)/(-0.373311285))
    ppmSmoke = 10**((math.log10(RS_RO_ratio)-1.617856412)/(-0.44340257))
    ppmPropane = 10**((math.log10(RS_RO_ratio)-1.290828982)/(-0.461038681))

    obj = {"name":"mq2","H2":ppmH2,"LPG":ppmLPG,"Methane":ppmMethane,"CO":ppmCO,"Alcohol":ppmAlcohol,"Smoke":ppmSmoke,"Propane":ppmPropane,"Unit":"ppm"}
    PostData(ppmSmoke)
    sendServer(obj)