import "./App.css";
import { Routes, Route, useLocation } from "react-router-dom";
import Home from "./pages/Home";
import MQ2 from "./pages/MQ2";
import DHT from "./pages/DHT";
import PMS3003 from "./pages/PMS3003";
import { useEffect, useState } from "react";

const App = () => {
  const location = useLocation();
  const [bg, setBg] = useState("#314d63");
  useEffect(() => {
    if (location.pathname === "/") {
      setBg("#314d63");
    } else {
      setBg("#a1c0d9");
    }
  });

  return (
    <>
      <div className="App" style={{ background: bg, height: "100vh" }}>
        <Routes>
          <Route path="/" element={<Home />} />
          <Route path="/mq2" element={<MQ2 />} />
          <Route path="/dht" element={<DHT />} />
          <Route path="/pms3003" element={<PMS3003 />} />
        </Routes>
      </div>
    </>
  );
};

export default App;
