import { useEffect, useState } from "react";
import "./styles/ShowValue.css";

const ShowValue = (props) => {
  const [sensor, setSensor] = useState({});
  useEffect(() => {
    const FetchMQ2 = async () => {
      const response = await fetch("http://172.20.10.6:60/");
      const data = await response.json();
      setSensor(data);
    };
    const FetchPM25 = async () => {
      const response = await fetch("http://172.20.10.13:60/");
      const data = await response.json();
      setSensor(data);
    };
    if (props.sensor === "mq2") {
      FetchMQ2();
    } else if (props.sensor === "pm25") {
      FetchPM25();
    }
  });
  return (
    <div>
      <div
        style={{
          display: "flex",
          flexWrap: "wrap",
          width: "500px",
          height: "380px",
          overflowY: "scroll",
          color: "#314d63",
        }}
      >
        {props.tags.map((tag, i = 0) => (
          <div className="ShowValue__box-value" key={i}>
            <div>
              <h2 style={{ fontSize: "1.5rem" }}>{tag.name}</h2>
              <h4
                style={{
                  fontSize: "1.3rem",
                  fontWeight: "600",
                }}
              >
                current value
              </h4>
              <h5 style={{ fontSize: "1.2rem", fontWeight: "400" }}>
                {sensor[tag.name] === undefined ? "-" : sensor[tag.name]}{" "}
                {tag.unit}
              </h5>
            </div>
          </div>
        ))}
      </div>
    </div>
  );
};

export default ShowValue;
