import Logo from "../components/Logo";
import { useEffect, useState } from "react";
import Thermometer from "react-thermometer-component";

const DHT = () => {
  const [sensor, setSensor] = useState({});
  useEffect(() => {
    const FetchMQ2 = async () => {
      const response = await fetch("http://172.20.10.4:62/");
      const data = await response.json();
      setSensor(data);
    };
    FetchMQ2();
  }, []);

  return (
    <div
      style={{
        display: "flex",
        justifyContent: "space-evenly",
      }}
    >
      <div
        style={{
          display: "flex",
          flexDirection: "column",
          justifyContent: "space-evenly",
        }}
      >
        <Logo />
        <div style={{ display: "flex", marginTop: "40px" }}>
          <div
            style={{
              display: "flex",
              flexDirection: "column",
              justifyContent: "center",
            }}
          >
            <h2
              style={{
                fontSize: "3rem",
                fontWeight: "700",
                letterSpacing: "5px",
              }}
            >
              TEMPERATURE
            </h2>
            <h4
              style={{
                fontSize: "1.2rem",
                fontWeight: "400",
                letterSpacing: "19px",
                marginRight: "20px",
              }}
            >
              CURRENT VALUE
            </h4>
          </div>
          <Thermometer
            theme="dark"
            value={sensor.Temperature}
            max="100"
            format="°C"
          />
        </div>
      </div>
      <div
        style={{
          display: "flex",
          flexDirection: "column",
          justifyContent: "space-evenly",
        }}
      >
        <Tracking />
        <div
          style={{ display: "flex", alignItems: "center", paddingLeft: "20px" }}
        >
          <div
            style={{
              display: "flex",
              flexDirection: "column",
            }}
          >
            <h2
              style={{
                fontSize: "3rem",
                fontWeight: "700",
                letterSpacing: "5px",
              }}
            >
              HUMIDITY
            </h2>
            <h4
              style={{
                fontSize: "1.2rem",
                fontWeight: "400",
                marginRight: "20px",
                letterSpacing: "10px",
              }}
            >
              CURRENT VALUE
            </h4>
          </div>
          <h5 style={{ fontSize: "5rem", marginLeft: "40px" }}>
            {sensor.Humidity === undefined ? "-" : sensor.Humidity} %
          </h5>
        </div>
      </div>
    </div>
  );
};

const Tracking = () => {
  return (
    <div
      style={{
        lineHeight: "1.1",
        paddingLeft: "20px",
      }}
    >
      <h2
        style={{
          fontSize: "3.9rem",
          fontWeight: "900",
          color: "#314d63",
          paddingBottom: "0",
        }}
      >
        DHT
        <span
          style={{
            fontSize: "1.5rem",
            marginLeft: "10px",
            letterSpacing: "4px",
          }}
        >
          (Sensor Temperature)
        </span>
      </h2>
      <h5
        style={{
          paddingTop: "0",
          fontSize: "4.8rem",
          fontWeight: "400",
          letterSpacing: "20px",
          color: "#314d63",
        }}
      >
        TRACKING
      </h5>
    </div>
  );
};

export default DHT;
