import Logo from "../components/Logo";
import ShowValue from "../components/ShowValue";
import { BarChart, Bar, XAxis, YAxis, Tooltip, CartesianGrid } from "recharts";
import { useEffect, useState } from "react";

// const mq2 = ["Alcohol", "CO", "H2", "LPG", "Methane", "Propane", "Smoke"];
let mq2 = [
  { name: "Alcohol", unit: "ppm" },
  { name: "CO", unit: "ppm" },
  { name: "H2", unit: "ppm" },
  { name: "LPG", unit: "ppm" },
  { name: "Methane", unit: "ppm" },
  { name: "Propane", unit: "ppm" },
  { name: "Smoke", unit: "ppm" },
];

const MQ2 = () => {
  const [sensor, setSensor] = useState([]);
  useEffect(() => {
    const FetchMQ2 = async () => {
      const response = await fetch("http://172.20.10.6:60/");
      const data = await response.json();
      let temp = [];
      Object.entries(data).forEach(([key, value]) => {
        if (key !== "name" && key !== "Unit") {
          temp.push({ name: key, value: value });
        }
      });
      setSensor(temp);
    };
    FetchMQ2();
  }, []);
  return (
    <div
      style={{
        display: "flex",
        flexDirection: "row",
        flexWrap: "wrap",
        justifyContent: "space-evenly",
      }}
    >
      <div>
        <Logo />
        <ShowValue sensor="mq2" tags={mq2} unit="ppm" />
      </div>
      <div
        style={{
          display: "flex",
          flexDirection: "column",
          justifyContent: "space-around",
        }}
      >
        <Tracking />
        <div>
          <BarChart width={600} height={300} data={sensor}>
            <XAxis dataKey="name" stroke="#8884d8" />
            <YAxis />
            <Tooltip />
            <CartesianGrid stroke="#ccc" strokeDasharray="5 5" />
            <Bar dataKey="value" fill="#8884d8" barSize={30} />
          </BarChart>
        </div>
      </div>
    </div>
  );
};

const Tracking = () => {
  return (
    <div
      style={{
        lineHeight: "1.1",
        paddingLeft: "20px",
      }}
    >
      <h2
        style={{
          fontSize: "3.9rem",
          fontWeight: "900",
          color: "#314d63",
          paddingBottom: "0",
        }}
      >
        MQ2
        <span
          style={{
            fontSize: "1.5rem",
            marginLeft: "10px",
            letterSpacing: "7px",
          }}
        >
          (Fire Detector)
        </span>
      </h2>
      <h5
        style={{
          paddingTop: "0",
          fontSize: "4.8rem",
          fontWeight: "400",
          letterSpacing: "10px",
          color: "#314d63",
        }}
      >
        TRACKING
      </h5>
    </div>
  );
};

export default MQ2;
